//ODEObject.cpp

#include "ODEObject.h"

ODEObject::ODEObject(bool body, dReal posx, dReal posy, dReal posz)
: Base3DObject(true, posx, posy, posz)
{
	//velocity.x = 0;
	//velocity.y = 0;
	//velocity.z = 0;

	hasBody = body;

	//Not implemented yet...
	//dBodySetAutoDisableSF1(thisBodyID, true);
}

ODEObject::~ODEObject()
{

}

void ODEObject::SetPosition(point3d newposition)
{
	position = newposition;

	//if (hasBody)
	//{
	//	dBodySetPosition(thisBodyID, position.x, position.y, position.z);
	//}
	//else // this object is only a geom
	//{
		dGeomSetPosition(thisGeomID, position.x, position.y, position.z);
	//}
}

point3d ODEObject::GetPosition()
{
	//if (dGeomGetBody(thisGeomID) != 0)
	//{
	//	const dReal* bodyPosition;
	//	bodyPosition = dBodyGetPosition(thisBodyID);
	//	position.x = bodyPosition[0];
	//	position.y = bodyPosition[1];
	//	position.z = bodyPosition[2];
	//}
	//else // this object is only a geom
	//{
		const dReal* geomPosition;
		geomPosition = dGeomGetPosition(thisGeomID);
		position.x = geomPosition[0];
		position.y = geomPosition[1];
		position.z = geomPosition[2];
	//}
	return position;
}

void ODEObject::SetOrientation(int axis, dReal angle)
{
	//orientation = neworientation;

	dQuaternion q;

	switch (axis)
	{
		case 0:
			dQFromAxisAndAngle(q, 1, 0, 0, angle);
			break;
		case 1:
			dQFromAxisAndAngle(q, 0, 1, 0, angle);
			break;
		case 2:
			dQFromAxisAndAngle(q, 0, 0, 1, angle);
			break;
		default:
			break;
	}

	dGeomSetQuaternion(thisGeomID, q);
}

//point3d ODEObject::GetOrientation()
//{
//	const dReal* geomPosition;
//	geomPosition = dGeomGetPosition(thisGeomID);
//	position.x = geomPosition[0];
//	position.y = geomPosition[1];
//	position.z = geomPosition[2];
//
//	return orientation;
//}

void ODEObject::SetVelocity(vector3d velocity)
{
	if (hasBody)
	{
		dBodySetLinearVel(thisBodyID, velocity.x, velocity.y, velocity.z);
	}
	else // this object is only a geom
	{
		//geoms have no velocity, so this shouldn't be called
	}
}

vector3d ODEObject::GetVelocity()
{
	const dReal* velocity;
	vector3d newVelocity = {0, 0, 0};

	if (hasBody)
	{
		velocity = dBodyGetLinearVel(thisBodyID);

		newVelocity.x = velocity[0];
		newVelocity.y = velocity[1];
		newVelocity.z = velocity[2];

		return newVelocity;
	}
	else // this object is only a geom
	{
		//geoms have no velocity, so this shouldn't be called
		return newVelocity;
	}
}

dBodyID ODEObject::GetBodyID()
{
	return thisBodyID;
}

void ODEObject::SetBodyID(dBodyID bodyID)
{
	thisBodyID = bodyID;
}

dGeomID ODEObject::GetGeomID()
{
	return thisGeomID;
}

void ODEObject::SetGeomID(dGeomID GeomID)
{
	thisGeomID = GeomID;
}

void ODEObject::Draw()
{

}

bool ODEObject::HasBody()
{
	return hasBody;
}

